# HG changeset patch
# Node ID 276e97d2d581
# Parent  358f8573573f
diff --git a/finch/gntblist.c b/finch/gntblist.c
--- a/finch/gntblist.c
+++ b/finch/gntblist.c
@@ -601,9 +601,12 @@ finch_request_add_buddy(G_GNUC_UNUSED Pu
 	purple_request_field_set_type_hint(field, "group");
 
 	field = purple_request_field_account_new("account", _("Account"), NULL);
-	purple_request_field_account_set_show_all(field, FALSE);
-	if (account)
-		purple_request_field_account_set_value(field, account);
+	purple_request_field_account_set_show_all(PURPLE_REQUEST_FIELD_ACCOUNT(field),
+	                                          FALSE);
+	if(account) {
+		purple_request_field_account_set_value(PURPLE_REQUEST_FIELD_ACCOUNT(field),
+		                                       account);
+	}
 	purple_request_group_add_field(group, field);
 
 	purple_request_fields(NULL, _("Add Buddy"), NULL, _("Please enter buddy information."),
@@ -689,9 +692,12 @@ finch_request_add_chat(G_GNUC_UNUSED Pur
 	purple_request_page_add_group(page, group);
 
 	field = purple_request_field_account_new("account", _("Account"), NULL);
-	purple_request_field_account_set_show_all(field, FALSE);
-	if (account)
-		purple_request_field_account_set_value(field, account);
+	purple_request_field_account_set_show_all(PURPLE_REQUEST_FIELD_ACCOUNT(field),
+	                                          FALSE);
+	if(account) {
+		purple_request_field_account_set_value(PURPLE_REQUEST_FIELD_ACCOUNT(field),
+		                                       account);
+	}
 	purple_request_group_add_field(group, field);
 
 	field = purple_request_field_string_new("name", _("Name"), name, FALSE);
diff --git a/finch/gntrequest.c b/finch/gntrequest.c
--- a/finch/gntrequest.c
+++ b/finch/gntrequest.c
@@ -360,12 +360,16 @@ request_fields_cb(GntWidget *button, Pur
 
 				purple_request_field_list_set_selected(field, selected);
 				g_list_free(selected);
-			}
-			else if (type == PURPLE_REQUEST_FIELD_ACCOUNT)
-			{
-				GntWidget *combo = g_object_get_data(G_OBJECT(field), "finch-ui-data");
-				PurpleAccount *acc = gnt_combo_box_get_selected_data(GNT_COMBO_BOX(combo));
-				purple_request_field_account_set_value(field, acc);
+
+			} else if (PURPLE_IS_REQUEST_FIELD_ACCOUNT(field)) {
+				GntWidget *combo = NULL;
+				PurpleAccount *acc = NULL;
+				PurpleRequestFieldAccount *afield = NULL;
+
+				combo = g_object_get_data(G_OBJECT(field), "finch-ui-data");
+				acc = gnt_combo_box_get_selected_data(GNT_COMBO_BOX(combo));
+				afield = PURPLE_REQUEST_FIELD_ACCOUNT(field);
+				purple_request_field_account_set_value(afield, acc);
 			}
 		}
 	}
@@ -529,14 +533,15 @@ add_account_to_combo(GntWidget *combo, P
 static GntWidget*
 create_account_field(PurpleRequestField *field)
 {
+	PurpleRequestFieldAccount *afield = PURPLE_REQUEST_FIELD_ACCOUNT(field);
 	gboolean all;
 	PurpleAccount *def;
 	GntWidget *combo = gnt_combo_box_new();
 
-	all = purple_request_field_account_get_show_all(field);
-	def = purple_request_field_account_get_value(field);
-	if (!def) {
-		def = purple_request_field_account_get_default_value(field);
+	all = purple_request_field_account_get_show_all(afield);
+	def = purple_request_field_account_get_value(afield);
+	if(!PURPLE_IS_ACCOUNT(def)) {
+		def = purple_request_field_account_get_default_value(afield);
 	}
 
 	if(all) {
@@ -662,7 +667,7 @@ finch_request_fields(const char *title, 
 				widget = create_choice_field(field);
 			} else if (type == PURPLE_REQUEST_FIELD_LIST) {
 				widget = create_list_field(field);
-			} else if (type == PURPLE_REQUEST_FIELD_ACCOUNT) {
+			} else if(PURPLE_IS_REQUEST_FIELD_ACCOUNT(field)) {
 				accountlist = create_account_field(field);
 				widget = accountlist;
 			} else {
@@ -912,6 +917,9 @@ finch_request_save_in_prefs(G_GNUC_UNUSE
 GntWidget *finch_request_field_get_widget(PurpleRequestField *field)
 {
 	GntWidget *ret = NULL;
+	if(PURPLE_IS_REQUEST_FIELD_ACCOUNT(field)) {
+		ret = create_account_field(field);
+	} else {
 	switch (purple_request_field_get_field_type(field)) {
 		case PURPLE_REQUEST_FIELD_BOOLEAN:
 			ret = create_boolean_field(field);
@@ -928,14 +936,12 @@ GntWidget *finch_request_field_get_widge
 		case PURPLE_REQUEST_FIELD_LIST:
 			ret = create_list_field(field);
 			break;
-		case PURPLE_REQUEST_FIELD_ACCOUNT:
-			ret = create_account_field(field);
-			break;
 		default:
 			purple_debug_error("GntRequest", "Unimplemented request-field %d\n",
 					purple_request_field_get_field_type(field));
 			break;
 	}
+	}
 	return ret;
 }
 
diff --git a/libpurple/meson.build b/libpurple/meson.build
--- a/libpurple/meson.build
+++ b/libpurple/meson.build
@@ -97,6 +97,7 @@ purple_coresources = [
 	'purplewhiteboarduiops.c',
 	'queuedoutputstream.c',
 	'request.c',
+	'request/purplerequestfieldaccount.c',
 	'request-datasheet.c',
 	'roomlist.c',
 	'savedstatuses.c',
@@ -219,6 +220,10 @@ purple_coreheaders = [
 	'xmlnode.h',
 ]
 
+purple_request_headers = [
+	'request/purplerequestfieldaccount.h',
+]
+
 purple_generated_sources = []
 
 # An environment for unit tests.
@@ -292,7 +297,7 @@ enums_c = enums[0]
 enums_h = enums[1]
 
 PURPLE_H_INCLUDES = []
-foreach header : purple_coreheaders + purple_mediaheaders + ['version.h', 'purpleenums.h']
+foreach header : purple_coreheaders + purple_mediaheaders + purple_request_headers + ['version.h', 'purpleenums.h']
 	PURPLE_H_INCLUDES += f'#include <libpurple/@header@>'
 endforeach
 purple_h_conf = configuration_data()
@@ -339,6 +344,9 @@ install_headers(purple_coreheaders,
 install_headers(purple_mediaheaders,
                 subdir : purple_include_base / 'media')
 
+install_headers(purple_request_headers,
+                subdir : purple_include_base / 'request')
+
 pkgconfig.generate(
     libpurple,
     name : 'libpurple3',
diff --git a/libpurple/plugins/idle/idle.c b/libpurple/plugins/idle/idle.c
--- a/libpurple/plugins/idle/idle.c
+++ b/libpurple/plugins/idle/idle.c
@@ -158,12 +158,14 @@ purple_idle_set_account_idle_time(G_GNUC
 	PurpleRequestPage *request;
 	PurpleRequestGroup *group;
 	PurpleRequestField *field;
+	PurpleRequestFieldAccount *afield;
 
 	group = purple_request_group_new(NULL);
 
 	field = purple_request_field_account_new("acct", _("Account"), NULL);
-	purple_request_field_account_set_filter(field, idleable_filter);
-	purple_request_field_account_set_show_all(field, FALSE);
+	afield = PURPLE_REQUEST_FIELD_ACCOUNT(field);
+	purple_request_field_account_set_filter(afield, idleable_filter);
+	purple_request_field_account_set_show_all(afield, FALSE);
 	purple_request_group_add_field(group, field);
 
 	field = purple_request_field_int_new("mins", _("Minutes"), 10, 0, 9999);
@@ -190,6 +192,7 @@ purple_idle_unset_account_idle_time(G_GN
 	PurpleRequestPage *request;
 	PurpleRequestGroup *group;
 	PurpleRequestField *field;
+	PurpleRequestFieldAccount *afield;
 
 	if (idled_accts == NULL)
 	{
@@ -200,8 +203,9 @@ purple_idle_unset_account_idle_time(G_GN
 	group = purple_request_group_new(NULL);
 
 	field = purple_request_field_account_new("acct", _("Account"), NULL);
-	purple_request_field_account_set_filter(field, unidle_filter);
-	purple_request_field_account_set_show_all(field, FALSE);
+	afield = PURPLE_REQUEST_FIELD_ACCOUNT(field);
+	purple_request_field_account_set_filter(afield, unidle_filter);
+	purple_request_field_account_set_show_all(afield, FALSE);
 	purple_request_group_add_field(group, field);
 
 	request = purple_request_page_new();
diff --git a/libpurple/purplerequestfield.h b/libpurple/purplerequestfield.h
--- a/libpurple/purplerequestfield.h
+++ b/libpurple/purplerequestfield.h
@@ -39,7 +39,7 @@
  */
 typedef struct _PurpleRequestField PurpleRequestField;
 
-#include "account.h"
+#include "request.h"
 #include "request-datasheet.h"
 
 #define PURPLE_DEFAULT_ACTION_NONE	-1
@@ -71,7 +71,6 @@ struct _PurpleRequestFieldClass {
  * @PURPLE_REQUEST_FIELD_LIST: List field.
  * @PURPLE_REQUEST_FIELD_LABEL: Label field.
  * @PURPLE_REQUEST_FIELD_IMAGE: Image field.
- * @PURPLE_REQUEST_FIELD_ACCOUNT: #PurpleAccount field.
  * @PURPLE_REQUEST_FIELD_DATASHEET: Datasheet field.
  *
  * A type of field.
@@ -86,7 +85,6 @@ typedef enum
 	PURPLE_REQUEST_FIELD_LIST,
 	PURPLE_REQUEST_FIELD_LABEL,
 	PURPLE_REQUEST_FIELD_IMAGE,
-	PURPLE_REQUEST_FIELD_ACCOUNT,
 	PURPLE_REQUEST_FIELD_DATASHEET
 
 } PurpleRequestFieldType;
@@ -887,118 +885,6 @@ unsigned int purple_request_field_image_
 unsigned int purple_request_field_image_get_scale_y(PurpleRequestField *field);
 
 /**************************************************************************/
-/* Account Field API                                                      */
-/**************************************************************************/
-
-/**
- * purple_request_field_account_new:
- * @id:      The field ID.
- * @text:    The text label of the field.
- * @account: The optional default account.
- *
- * Creates an account field.
- *
- * By default, this field will not show offline accounts.
- *
- * Returns: (transfer full): The new field.
- */
-PurpleRequestField *purple_request_field_account_new(const char *id,
-												 const char *text,
-												 PurpleAccount *account);
-
-/**
- * purple_request_field_account_set_default_value:
- * @field:         The account field.
- * @default_value: The default account.
- *
- * Sets the default account on an account field.
- */
-void purple_request_field_account_set_default_value(PurpleRequestField *field,
-												  PurpleAccount *default_value);
-
-/**
- * purple_request_field_account_set_value:
- * @field: The account field.
- * @value: The account.
- *
- * Sets the account in an account field.
- */
-void purple_request_field_account_set_value(PurpleRequestField *field,
-										  PurpleAccount *value);
-
-/**
- * purple_request_field_account_set_show_all:
- * @field:    The account field.
- * @show_all: Whether or not to show all accounts.
- *
- * Sets whether or not to show all accounts in an account field.
- *
- * If TRUE, all accounts, online or offline, will be shown. If FALSE,
- * only online accounts will be shown.
- */
-void purple_request_field_account_set_show_all(PurpleRequestField *field,
-											 gboolean show_all);
-
-/**
- * purple_request_field_account_set_filter:
- * @field:       The account field.
- * @filter_func: (scope notified): The account filter function.
- *
- * Sets the account filter function in an account field.
- *
- * This function will determine which accounts get displayed and which
- * don't.
- */
-void purple_request_field_account_set_filter(PurpleRequestField *field,
-										   PurpleFilterAccountFunc filter_func);
-
-/**
- * purple_request_field_account_get_default_value:
- * @field: The field.
- *
- * Returns the default account in an account field.
- *
- * Returns: (transfer none): The default account.
- */
-PurpleAccount *purple_request_field_account_get_default_value(PurpleRequestField *field);
-
-/**
- * purple_request_field_account_get_value:
- * @field: The field.
- *
- * Returns the user-entered account in an account field.
- *
- * Returns: (transfer none): The user-entered account.
- */
-PurpleAccount *purple_request_field_account_get_value(PurpleRequestField *field);
-
-/**
- * purple_request_field_account_get_show_all:
- * @field: The account field.
- *
- * Returns whether or not to show all accounts in an account field.
- *
- * If TRUE, all accounts, online or offline, will be shown. If FALSE,
- * only online accounts will be shown.
- *
- * Returns: Whether or not to show all accounts.
- */
-gboolean purple_request_field_account_get_show_all(PurpleRequestField *field);
-
-/**
- * purple_request_field_account_get_filter:
- * @field: The account field.
- *
- * Returns the account filter function in an account field.
- *
- * This function will determine which accounts get displayed and which
- * don't.
- *
- * Returns: (transfer none): The account filter function.
- */
-PurpleFilterAccountFunc purple_request_field_account_get_filter(PurpleRequestField *field);
-
-/**************************************************************************/
 /* Datasheet Field API                                                    */
 /**************************************************************************/
 
